Summary:	The PHP scripting language.
Name:		php
Group:		Development/Languages
License:	PHP
Version:	4.3.11
Release:	3
Source0:	http://www.php.net/distributions/php-%{version}.tar.gz
Patch0:		php-4.3.8-php.ini-gd-1.diff
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
BuildPrereq:	apache-devel
Prereq:		apache
ExcludeArch:	ia64

%description
PHP is an HTML-embeddable scripting language.  PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple.  The
most common use of PHP coding is probably as a replacement for CGI scripts.

%files
  %defattr(-,root,root)
  %doc CREDITS INSTALL LICENSE EXTENSIONS TODO NEWS README.* Zend/ZEND_*
  %attr(0644,root,root)		%config %{_sysconfdir}/php.ini
  %attr(0511,root,root)		%{_bindir}/php
  %attr(700,webd,root)		%{_var}/run/php
  %attr(640,webd,root)		%{_var}/log/httpd/php_error.log

%package -n mod_php
Summary:	The PHP HTML-embedded scripting language for use with Apache.
Group:		System Environment/Daemons
Prereq:		webserver
Obsoletes:	php3, phpfi
BuildPrereq:	apache-devel
Prereq:		php = %{version}-%{release}

%description -n mod_php
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most common
use of PHP coding is probably as a replacement for CGI scripts.  The
mod_php module enables the Apache web server to understand and process
the embedded PHP language in web pages.

This package contains PHP version 4.0.  You'll also need to install the
Apache web server.

%files -n mod_php
  %defattr(-,root,root)
  %attr(0500,root,root)		%{_libexecdir}/apache/mod_php.so

%package mysql
Summary:	A module for PHP applications that use MySQL databases.
Group:		Development/Languages
Prereq:		php = %{version}-%{release}, perl
Provides:	php_database
Obsoletes:	mod_php3-mysql
BuildPrereq:	MySQL-devel
Requires:	MySQL

%description mysql
The php-mysql package contains a dynamic shared object that will add
MySQL database support to PHP.  MySQL is an object-relational database
management system.  PHP is an HTML-embeddable scripting language.  If
you need MySQL support for PHP applications, you will need to install
this package and the php or mod_php package.

%files mysql
  %defattr(-,root,root)
  %attr(0500,root,root)		%{_libdir}/php/extensions/mysql.so

%package imap
Summary:	A module for PHP applications that use IMAP.
Group:		Development/Languages
Prereq:		php = %{version}-%{release}, perl
Requires:	imap, pam
BuildPrereq:	imap-devel

%description imap
The php-imap package contains a dynamic shared object that will add IMAP
(Internet Message Access Protocol) support to PHP. IMAP is a protocol
for retrieving, uploading, and manipulating e-mail messages on mail servers.
PHP is an HTML-embeddable scripting language.  If you need IMAP support
for PHP applications, you will need to install this package and the php

%files imap
  %defattr(-,root,root)
  %attr(0500,root,root)		%{_libdir}/php/extensions/imap.so

%prep
%setup -q
  cp Zend/LICENSE Zend/ZEND_LICENSE
  ./buildconf --force
%patch0 -p1

%build
  CFLAGS="$RPM_OPT_FLAGS -fPIC"; export CFLAGS

  # Function used for building both php standalone and module.
  compile() {
	./configure \
		--prefix=%{_prefix} \
		--sysconfdir=%{_sysconfdir} \
		--with-config-file-path=%{_sysconfdir} \
		--disable-debug \
		--enable-pic \
		--enable-inline-optimization \
		--with-exec-dir=%{_bindir} \
		--with-regex=system \
		--with-gettext \
		--with-gdbm \
		--without-mysql \
		--with-xml \
		--with-zlib \
		--with-jpeg-dir=/usr \
		--enable-magic-quotes \
		--enable-safe-mode \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-track-vars \
		--enable-ftp \
		--enable-calender \
		--enable-sockets \
		--enable-bcmath \
		--enable-pear \
		--disable-yp \
		--with-openssl \
		--enable-versioning \
		--enable-force-cgi-redirect \
		$*
	make %{?_smp_mflags}
  }
#		--with-ldap \

  # Function used for building PHP modules.
  build_ext() {
	%{__cc} -fPIC -shared $RPM_OPT_FLAGS \
		-DCOMPILE_DL_`echo $1 | tr '[a-z]' '[A-Z]'` \
		-DHAVE_`echo $1 | tr '[a-z]' '[A-Z]'` \
		-I. -I./main -I`%{_sbindir}/apxs -q INCLUDEDIR` -I./Zend \
		-I/usr/include/freetype -I/usr/include/$1 \
		-I./ext/$1 -I./ext/$1/lib$1 \
		-I./ext/xml/expat/xmltok -I./ext/xml/expat/xmlparse \
		-I./TSRM \
		`grep ^CPPFLAGS Zend/Makefile | cut -f2- -d=` \
		$4 $2 -o $1.so -L.libs $3 -lc
  }


  # Build the standalone binary.
  compile --enable-force-cgi-redirect --enable-discard-path --enable-static
  cp sapi/cli/php php_standalone
  make distclean

  # Build the apache module.
  compile --with-apxs2=%{_sbindir}/apxs

  # Build PHP modules (mysql and imap).
  build_ext mysql ext/mysql/php_mysql.c "-L/usr/lib/mysql -lmysqlclient" "-DHAVE_MYSQL_MYSQL_H -DHAVE_MYSQL_REAL_CONNECT"
  build_ext imap ext/imap/php_imap.c "%{_libdir}/libc-client.a -lpam" "-DHAVE_IMAP2000"

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

  mkdir -p $RPM_BUILD_ROOT/%{_bindir}
  mkdir -p $RPM_BUILD_ROOT/%{_libdir}/php/extensions
  mkdir -p $RPM_BUILD_ROOT/%{_libexecdir}/apache
  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}
  mkdir -p $RPM_BUILD_ROOT/%{_var}/log/httpd
  mkdir -p $RPM_BUILD_ROOT/%{_var}/run/php

  install php_standalone   $RPM_BUILD_ROOT%{_bindir}/php
  install .libs/libphp4.so $RPM_BUILD_ROOT%{_libexecdir}/apache/mod_php.so

  strip -g $RPM_BUILD_ROOT%{_libexecdir}/apache/*.so

  install mysql.so $RPM_BUILD_ROOT%{_libdir}/php/extensions/
  install imap.so $RPM_BUILD_ROOT%{_libdir}/php/extensions/
  strip -g $RPM_BUILD_ROOT%{_libdir}/php/extensions/*

  install php.ini-dist $RPM_BUILD_ROOT/etc/php.ini

  touch $RPM_BUILD_ROOT/%{_var}/log/httpd/php_error.log

%post -n mod_php
  %{__perl}  -pi -e 's|^#LoadModule php4_module        modules/libphp4.so|LoadModule php4_module        %{_libexecdir}/apache/mod_php.so|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddModule mod_php4.c|AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddType application/x-httpd-php3 .php3|AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddType application/x-httpd-php .php4|AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^#AddType application/x-httpd-php .php|AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf

  # Ugly hack to fix my mistake (see 2000/11/22 changelog entry)
  %{__perl}  -pi -e 's|^LoadModule php4_module        modules/libphp4.so| LoadModule php4_module        %{_libexecdir}/apache/mod_php.so|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddModule mod_php4.c| AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php3 .php3| AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php .php4| AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
  %{__perl}  -pi -e 's|^AddType application/x-httpd-php .php| AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf

  # Maybe restart Apache.
  if [ -f /var/lock/subsys/httpd ]; then
        /etc/init.d/httpd restart > /dev/null 2>&1 || :
  fi

%postun -n mod_php
  if [ $1 = 0 ]; then
	%{__perl}  -pi -e 's|^LoadModule php4_module        modules/libphp4.so|#LoadModule php4_module        %{_libexecdir}/apache/mod_php.so|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddModule mod_php4.c|#AddModule mod_php4.c|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddType application/x-httpd-php3 .php3|#AddType application/x-httpd-php3 .php3|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddType application/x-httpd-php .php4|#AddType application/x-httpd-php .php4|g' /etc/httpd/conf/httpd.conf
	%{__perl}  -pi -e 's|^AddType application/x-httpd-php .php|#AddType application/x-httpd-php .php|g' /etc/httpd/conf/httpd.conf
  fi

  # Maybe restart Apache.
  if [ -f /var/lock/subsys/httpd ]; then
        /etc/init.d/httpd restart > /dev/null 2>&1 || :
  fi

%post mysql
  %{__perl} -pi -e "s|^;extension=mysql.so|extension=mysql.so|" /etc/php.ini

%preun mysql
  if [ $1 = 0 ] ; then
	%{__perl} -pi -e "s|^extension=mysql.so|;extension=mysql.so|" /etc/php.ini
  fi

%post imap
  %{__perl} -pi -e "s|^;extension=imap.so|extension=imap.so|" /etc/php.ini

%preun imap
  if [ $1 = 0 ] ; then
	%{__perl} -pi -e "s|^extension=imap.so|;extension=imap.so|" /etc/php.ini
  fi

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Aug 11 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.3.11, Release 3
  - Happy Birthday Christi!
  - Disable ldap for now because we don't have it in x86_64 yet.
  - Bump release to avoid confusion.

* Fri Jul 08 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.3.11, Release 2
  - Rebuild against openssl-0.9.8.

* Tue Jun 28 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 4.3.11, Release 1
  - Initial build for EnGarde Secure Linux 3.0.
